#-----------------------------------------------------------------------------

from Tkinter import *
import poser
import os
scene = poser.Scene()

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
	def __init__(self, master, textMessage):
		self.master = master
		master.title("Convert colors")
		Label(self.master,text='R',bg="pink").grid(row=0,column=0)
		self.REntry = Entry(self.master,width=12)
		self.REntry.grid(row=0,column=1)
		Label(self.master,text='G',bg="lightgreen").grid(row=0,column=2)
		self.GEntry = Entry(self.master,width=12)
		self.GEntry.grid(row=0,column=3)
		Label(self.master,text='B',bg="lightblue").grid(row=0,column=4)
		self.BEntry = Entry(self.master,width=12)
		self.BEntry.grid(row=0,column=5)

		# Go/nogo buttons.
		self.buttonGo = Button(self.master, text="To RGB", command=self.HandleToRGB)
		self.buttonGo.grid(row=0, column=6,padx=4,pady=4)
		self.buttonGo = Button(self.master, text="To Kd", command=self.HandleToKd)
		self.buttonGo.grid(row=0, column=7,padx=4,pady=4)

		self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


	# - - - - - - - - - - - - - - - - - -

	def Update(self):
		if scene: scene.ProcessSomeEvents()
		root.lift()
		root.after(100, self.Update)

	# - - - - - - - - - - - - - - - - - -

	def HandleToRGB(self):
		Rs=self.REntry.get()
		if not Rs: R = 0
		else:	   R = float(Rs)
		Gs=self.GEntry.get()
		if not Gs: G = 0
		else:	   G = float(Gs)
		Bs=self.BEntry.get()
		if not Bs: B = 0
		else:	   B = float(Bs)
		if	 R>1.0: R=1.0
		elif R<0.0: R=0.0
		if	 G>1.0: G=1.0
		elif G<0.0: G=0.0
		if	 B>1.0: B=1.0
		elif B<0.0: B=0.0
		Rk=int(0.5 + R*255.0)
		Gk=int(0.5 + G*255.0)
		Bk=int(0.5 + B*255.0)
		self.REntry.delete(0,END)
		self.REntry.insert(0,str(Rk))
		self.GEntry.delete(0,END)
		self.GEntry.insert(0,str(Gk))
		self.BEntry.delete(0,END)
		self.BEntry.insert(0,str(Bk))

	# - - - - - - - - - - - - - - - - - -

	def HandleToKd(self):
		Rs=self.REntry.get()
		if not Rs: R = 0
		else:	   R = int(float(Rs))
		Gs=self.GEntry.get()
		if not Gs: G = 0
		else:	   G = int(float(Gs))
		Bs=self.BEntry.get()
		if not Bs: B = 0
		else:	   B = int(float(Bs))
		if	 R>255: R=255
		elif R<0:	R=0
		if	 G>255: G=255
		elif G<0:	G=0
		if	 B>255: B=255
		elif B<0:	B=0

		Rs="%.5f" % (R*1.0/255.0)
		Gs="%.5f" % (G*1.0/255.0)
		Bs="%.5f" % (B*1.0/255.0)

		self.REntry.delete(0,END)
		self.REntry.insert(0,Rs)

		self.GEntry.delete(0,END)
		self.GEntry.insert(0,Gs)

		self.BEntry.delete(0,END)
		self.BEntry.insert(0,Bs)

	# - - - - - - - - - - - - - - - - - -

	def HandleCancel(self):
		self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
